void Blit_ZWing_Character(int x, int y, unsigned char t) {
   //Uses the ROM 8x8 character set to blit a character on the screen.

   unsigned char far *work_char;
   unsigned char bit_mask;
   int xx, yy, l=0, c;

   //Compute starting offset into table.
   work_char = ascii_text + (t << 3);

   for (yy=y; yy < y + CHAR_HEIGHT; yy++) {
      bit_mask = 0x80;
      for (xx=x; xx < x + CHAR_WIDTH; xx++) {
         if (bit_mask & *work_char) {
            if (l < 1) c=74;
            else if (l < 5) c=65;
            else c=66;
            SetPixel(xx,yy,c);
         }
         bit_mask = bit_mask >> 1;
      }
      l++;

      work_char++;
   }
   return;
}


void Blit_ZWing_String(char * string, int x, int y, bool clear, bool center=false) {

   int index=0,c;

   if (center) {
      x=(236-strlen(string)*8)/2+42;
   }

   while (string[index] != '\0') {
      if (clear) {
         Blit_Character(x,y,string[index],79,79,false);
      } else {
         Blit_ZWing_Character(x, y, string[index]);
      }
      index++;
      x += CHAR_WIDTH;
      for (c=0; c < 4 && !clear && string[index]!=' '; c++) {
         Wait_For_Vertical_Retrace();
      }
   }
   return;
}


void Intro(void) {
   int c;
   
   Set_Video_Mode(VGA256);

   //Show_PCX("ayb.pcx");

   //Blit_ZWing_String("CATS: ALL YOUR BASE ARE BELONG",42,160, false);
   //Blit_ZWing_String("TO US.",90,158, false);

   //Scene 1: In A.D. 2001

   Show_PCX("inad2101.pcx", true);
   Blit_ZWing_String("IN A.D. 2001",112,160, false, true);
   
   for (c=0; c < 60; c++) {Wait_For_Vertical_Retrace();}

   Blit_ZWing_String("IN A.D. 2001",112,160, true, true);

   Blit_ZWing_String("A PROJECT WAS ASSIGNED",0,160, false, true);

   for (c=0; c < 120; c++) {Wait_For_Vertical_Retrace();}

   Fade_Out();

   //Scene 2: Someone set up us the assignment

   Show_PCX("whathapn.pcx", true);
   Blit_ZWing_String("ADAM: WHAT HAPPEN ?",42,160, false);
   
   for (c=0; c < 120; c++) {Wait_For_Vertical_Retrace();}

   Blit_ZWing_String("ADAM: WHAT HAPPEN ?",42,160, true);

   Blit_ZWing_String("MECHANIC: SOMEBODY SET UP US",42,160, false);
   Blit_ZWing_String("          THE ASSIGNMENT.",42,168, false);

   for (c=0; c < 160; c++) {Wait_For_Vertical_Retrace();}

   Show_PCX("getsignl.pcx", false);

   Blit_ZWing_String("OPERATOR: WE GET SIGNAL.",42,160, false);

   for (c=0; c < 60; c++) {Wait_For_Vertical_Retrace();}

   Blit_ZWing_String("ADAM: WHAT !",42,170, false);

   for (c=0; c < 100; c++) {Wait_For_Vertical_Retrace();}

   Show_PCX("whathapn.pcx", false);

   Blit_ZWing_String("OPERATOR: MAIN SCREEN TURN ON.",42, 160, false);

   for (c=0; c < 100; c++) {Wait_For_Vertical_Retrace();}

   Show_PCX("itsyou.pcx", false);
   
   Blit_ZWing_String("ADAM: IT'S YOU !!",42, 160, false);

   for (c=0; c < 120; c++) {Wait_For_Vertical_Retrace();}

   Fade_Out();

   //Scene 3: All your grade are belong to us

   Show_PCX("ayb.pcx", true);

   Blit_ZWing_String("PERKA: HOW ARE YOU MR. GASHLIN !!", 42, 160, false);

   for (c=0; c < 100; c++) {Wait_For_Vertical_Retrace();}

   Blit_ZWing_String("PERKA: HOW ARE YOU MR. GASHLIN !!", 42, 160, true);

   Blit_ZWing_String("PERKA: ALL YOUR GRADE ARE BELONG", 42, 160, false);
   Blit_ZWing_String("       TO US.", 42, 168, false);

   for (c=0; c < 120; c++) {Wait_For_Vertical_Retrace();}

   Blit_ZWing_String("PERKA: ALL YOUR GRADE ARE BELONG", 42, 160, true);
   Blit_ZWing_String("       TO US.", 42, 168, true);

   Blit_ZWing_String("PERKA: YOU ARE ON THE WAY TO", 42, 160, false);
   Blit_ZWing_String("       FAILURE.", 42, 168, false);

   for (c=0; c < 90; c++) {Wait_For_Vertical_Retrace();}

   Show_PCX("whtyousy.pcx",false);
   
   Blit_ZWing_String("ADAM: WHAT YOU SAY !!", 42, 160, false);
   
   for (c=0; c < 90; c++) {Wait_For_Vertical_Retrace();}

   Show_PCX("maketime.pcx",false);

   Blit_ZWing_String("PERKA: YOU HAVE NO CHANCE TO", 42, 160, false);
   Blit_ZWing_String("       PASS MAKE YOUR TIME.", 42, 168, false);

   for (c=0; c < 90; c++) {Wait_For_Vertical_Retrace();}

   //Fade_Out();

   Show_PCX("itsyou.pcx", false);

   Blit_ZWing_String("PERKA: HA HA HA HA ....", 42, 160, false);

   for (c=0; c < 90; c++) {Wait_For_Vertical_Retrace();}

   Fade_Out();

   //Scene 4: For great justice
   
   Show_PCX("captain.pcx", true);

   for (c=0; c < 90; c++) {Wait_For_Vertical_Retrace();}

   Blit_ZWing_String("OPERATOR: ADAM !!", 42, 160, false);

   for (c=0; c < 120; c++) {Wait_For_Vertical_Retrace();}

   Fade_Out();
   
   Show_PCX("zig.pcx", true);

   Blit_ZWing_String("ADAM: TAKE OFF EVERY 'DISK' !!", 42, 160, false);
   
   for (c=0; c < 120; c++) {Wait_For_Vertical_Retrace();}

   Show_PCX("ykwyd.pcx", false);

   Blit_ZWing_String("ADAM: YOU KNOW WHAT YOU DOING.", 42, 160, false);

   for (c=0; c < 60; c++) {Wait_For_Vertical_Retrace();}

   Fade_Out();
   
   Show_PCX("movezig.pcx", true);

   Blit_ZWing_String("ADAM: MOVE 'MOUSE'.", 42, 160, false);

   for (c=0; c < 120; c++) {Wait_For_Vertical_Retrace();}

   Fade_Out();
   
   Show_PCX("zig.pcx", true);

   Blit_ZWing_String("ADAM: FOR GREAT JUSTICE.", 42, 160, false);

   for (c=0; c < 240; c++) {Wait_For_Vertical_Retrace();}
   
   Fade_Out();
   
   return;
}
